diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index d28b49aa0..28afea31c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -13,15 +13,18 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
@@ -39,14 +42,14 @@ interface BlockInterface {
     boolean canPlaceOnSurface();
 
     @Deprecated
-    boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final int x, final int y, final int z) {
         return this.canPlaceOnSurfaceOnCondition(world, new TilePos(x, y, z));
     }
 
-    boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource world, final int x, final int y, final int z) {
@@ -54,7 +57,7 @@ interface BlockInterface {
     }
 
     @Deprecated
-    boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean canPlaceOnSurfaceOfBlock(final @NotNull World world, final int x, final int y, final int z) {
@@ -64,7 +67,7 @@ interface BlockInterface {
     /**
      * Make sure if this gets overridden in a block that {@link net.minecraft.core.block.Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
      */
-    @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity);
+    @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity);
 
     /**
      * Make sure if this gets overridden in a block that {@link net.minecraft.core.block.Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
@@ -76,18 +79,18 @@ interface BlockInterface {
 
     @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity);
 
-    @NotNull AABB getBounds();
+    @NotNull AABBdc getBounds();
 
-    @NotNull AABB getBoundsRaw();
+    @NotNull AABBd getBoundsRaw();
 
-    float getBrightness(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    float getBrightness(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default float getBlockBrightness(final @NotNull WorldSource source, final int x, final int y, final int z) {
         return this.getBrightness(source, new TilePos(x, y, z));
     }
 
-    int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getLightmapCoord(final @NotNull WorldSource source, final int x, final int y, final int z) {
@@ -97,7 +100,7 @@ interface BlockInterface {
     /**
      * Used when fullbright or lightmap is active
      */
-    float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     /**
      * Used when fullbright or lightmap is active
@@ -107,38 +110,38 @@ interface BlockInterface {
         return this.getAmbientOcclusionStrength(source, new TilePos(x, y, z));
     }
 
-    @NotNull AABB getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    @NotNull AABBdc getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
-    default @NotNull AABB getSelectedBoundingBoxFromPool(final @NotNull WorldSource world, final int x, final int y, final int z) {
+    default @NotNull AABBdc getSelectedBoundingBoxFromPool(final @NotNull WorldSource world, final int x, final int y, final int z) {
         return this.getSelectionAABB(world, new TilePos(x, y, z));
     }
 
-    @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePos tilePos);
+    @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final int x, final int y, final int z) {
         return this.getBoundingVolume(world, new TilePos(x, y, z));
     }
 
-    void getCollisionAABBs(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList);
+    void getCollisionAABBs(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList);
 
     @Deprecated
-    default void getCollidingBoundingBoxes(final @NotNull World world, final int x, final int y, final int z, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList) {
+    default void getCollidingBoundingBoxes(final @NotNull World world, final int x, final int y, final int z, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList) {
         this.getCollisionAABBs(world, new TilePos(x, y, z), aabb, aabbList);
     }
 
-    boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final int x, final int y, final int z) {
         return this.collidesWithEntity(entity, world, new TilePos(x, y, z));
     }
 
-    @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
-    default @Nullable AABB getCollisionBoundingBoxFromPool(final @NotNull WorldSource source, final int x, final int y, final int z) {
+    default @Nullable AABBdc getCollisionBoundingBoxFromPool(final @NotNull WorldSource source, final int x, final int y, final int z) {
         return this.getCollisionAABB(source, new TilePos(x, y, z));
     }
 
@@ -150,21 +153,21 @@ interface BlockInterface {
 
     boolean isCollidable();
 
-    void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick);
+    void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick);
 
     @Deprecated
     default void updateTick(final @NotNull World world, final int x, final int y, final int z, final @NotNull Random rand, final boolean isRandomTick) {
         this.updateTick(world, new TilePos(x, y, z), rand, isRandomTick);
     }
 
-    void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand);
+    void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand);
 
     @Deprecated
     default void animationTick(final @NotNull World world, final int x, final int y, final int z, final @NotNull Random rand) {
         this.animationTick(world, new TilePos(x, y, z), rand);
     }
 
-    void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id);
+    void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id);
 
     @Deprecated
     default void onNeighborBlockChange(final @NotNull World world, final int x, final int y, final int z, final int id) {
@@ -173,14 +176,14 @@ interface BlockInterface {
 
     int tickDelay();
 
-    void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos);
+    void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default void onBlockPlacedByWorld(final @NotNull World world, final int x, final int y, final int z) {
         this.onPlacedByWorld(world, new TilePos(x, y, z));
     }
 
-    void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data);
+    void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data);
 
     /**
      * Always called when a block is removed by setBlock
@@ -193,7 +196,7 @@ interface BlockInterface {
     /**
      * Called when a block has been broken by a player, after {@link net.minecraft.core.block.Block#onBlockRemoved(World, int, int, int, int)}
      */
-    void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item);
+    void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item);
 
     /**
      * Called when a block has been broken by a player, after {@link net.minecraft.core.block.Block#onBlockRemoved(World, int, int, int, int)}
@@ -203,7 +206,7 @@ interface BlockInterface {
         this.onDestroyedByPlayer(world, new TilePos(x, y, z), side, data, player, item);
     }
 
-    float getStrength(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Player player);
+    float getStrength(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Player player);
 
     @Deprecated
     default float blockStrength(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side, final @NotNull Player player) {
@@ -214,80 +217,80 @@ interface BlockInterface {
 
     float getBlastResistance(final @Nullable Entity entity);
 
-    @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Vec3 start, final @NotNull Vec3 end, final boolean useSelectionAABB);
+    @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final boolean useSelectionAABB);
 
     @Deprecated
-    default @Nullable HitResult collisionRayTrace(final @NotNull World world, final int x, final int y, final int z, final @NotNull Vec3 start, final @NotNull Vec3 end, final boolean useSelectionAABB) {
+    default @Nullable HitResult collisionRayTrace(final @NotNull World world, final int x, final int y, final int z, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final boolean useSelectionAABB) {
         return this.collisionRayTrace(world, new TilePos(x, y, z), start, end, useSelectionAABB);
     }
 
-    void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePos tilePos);
+    void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default void onBlockDestroyedByExplosion(final @NotNull World world, final int x, final int y, final int z) {
         this.onDestroyedByExplosion(world, new TilePos(x, y, z));
     }
 
-    boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side);
+    boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     @Deprecated
     default boolean canPlaceBlockOnSide(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side) {
         return this.canPlaceOnSide(world, new TilePos(x, y, z), side);
     }
 
-    boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean canPlaceBlockAt(final @NotNull World world, final int x, final int y, final int z) {
         return this.canPlaceAt(world, new TilePos(x, y, z));
     }
 
-    boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit);
+    boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit);
 
     @Deprecated
     default boolean onBlockRightClicked(final @NotNull World world, final int x, final int y, final int z, final @Nullable Player player, final @Nullable Side side, final double xHit, final double yHit) {
         return this.onInteracted(world, new TilePos(x, y, z), player, side, xHit, yHit);
     }
 
-    void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction);
+    void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction);
 
     @Deprecated
     default void onActivatorInteract(final @NotNull World world, final int x, final int y, final int z, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         this.onActivatorInteracted(world, new TilePos(x, y, z), activator, direction);
     }
 
-    void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity walker);
+    void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker);
 
     @Deprecated
     default void onEntityWalking(final @NotNull World world, final int x, final int y, final int z, final @NotNull Entity entity) {
         this.onEntityWalkedOn(world, new TilePos(x, y, z), entity);
     }
 
-    void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit);
+    void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit);
 
     @Deprecated
     default void onBlockLeftClicked(final @NotNull World world, final int x, final int y, final int z, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
         this.onAttacked(world, new TilePos(x, y, z), player, side, xHit, yHit);
     }
 
-    void onEntityInside(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity, final @NotNull Vec3 velocity);
+    void onEntityInside(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity, final @NotNull Vector3d velocityDirection);
 
     @Deprecated
-    default void handleEntityInside(final @NotNull World world, final int x, final int y, final int z, final @NotNull Entity entity, final @NotNull Vec3 velocity) {
-        this.onEntityInside(world, new TilePos(x, y, z), entity, velocity);
+    default void handleEntityInside(final @NotNull World world, final int x, final int y, final int z, final @NotNull Entity entity, final @NotNull Vector3d velocityDirection) {
+        this.onEntityInside(world, new TilePos(x, y, z), entity, velocityDirection);
     }
 
-    @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
-    default @NotNull AABB getBlockBoundsFromState(final @NotNull WorldSource world, final int x, final int y, final int z) {
+    default @NotNull AABBdc getBlockBoundsFromState(final @NotNull WorldSource world, final int x, final int y, final int z) {
         return this.getBoundsFromState(world, new TilePos(x, y, z));
     }
 
     /**
      * Gets the redstone signal output by the block itself, i.e. the power it will provide to any immediately adjacent redstone components.
      */
-    boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side);
+    boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     /**
      * Gets the redstone signal output by the block itself, i.e. the power it will provide to any immediately adjacent redstone components.
@@ -299,14 +302,14 @@ interface BlockInterface {
 
     boolean isSignalSource();
 
-    void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity);
+    void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity);
 
     @Deprecated
     default void onEntityCollidedWithBlock(final @NotNull World world, final int x, final int y, final int z, final @NotNull Entity entity) {
         this.onEntityCollision(world, new TilePos(x, y, z), entity);
     }
 
-    boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side);
+    boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     /**
      * Gets the redstone signal pushed into adjacent solid blocks. Any block experiencing *direct* signal will power itself and all adjacent blocks.
@@ -316,42 +319,42 @@ interface BlockInterface {
         return this.isEmittingDirectSignal(world, new TilePos(x, y, z), side);
     }
 
-    void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity);
+    void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity);
 
     @Deprecated
     default void harvestBlock(final @NotNull World world, final @NotNull Player player, final int x, final int y, final int z, final int data, final @Nullable TileEntity tileEntity) {
         this.onHarvest(world, player, new TilePos(x, y, z), data, tileEntity);
     }
 
-    void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player);
+    void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player);
 
     @Deprecated
     default void dropBlockWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int x, final int y, final int z, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
         this.dropWithCause(world, dropCause, new TilePos(x, y, z), data, tileEntity, player);
     }
 
-    @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side);
+    @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     @Deprecated
     default @NotNull ISupport getSupport(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side) {
         return this.getSupport(world, new TilePos(x, y, z), side);
     }
 
-    boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean canBlockStay(final @NotNull World world, final int x, final int y, final int z) {
         return this.canStay(world, new TilePos(x, y, z));
     }
 
-    void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit);
+    void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit);
 
     @Deprecated
     default void onBlockPlacedByMob(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         this.onPlacedByMob(world, new TilePos(x, y, z), side, mob, xHit, yHit);
     }
 
-    void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit);
+    void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit);
 
     @Deprecated
     default void onBlockPlacedOnSide(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side, final double xHit, final double yHit) {
@@ -360,42 +363,42 @@ interface BlockInterface {
 
     @NotNull String getLanguageKey(final int data);
 
-    void triggerEvent(final @NotNull World world, final @NotNull TilePos tilePos, final int index, final int data);
+    void triggerEvent(final @NotNull World world, final @NotNull TilePosc tilePos, final int index, final int data);
 
     @Deprecated
     default void triggerEvent(final @NotNull World world, final int x, final int y, final int z, final int index, final int data) {
         this.triggerEvent(world, new TilePos(x, y, z), index, data);
     }
 
-    int getPistonPushReaction(final @NotNull World world, final @NotNull TilePos tilePos);
+    int getPistonPushReaction(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getPistonPushReaction(final @NotNull World world, final int x, final int y, final int z) {
         return this.getPistonPushReaction(world, new TilePos(x, y, z));
     }
 
-    int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit);
+    int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit);
 
     @Deprecated
     default int getPlacedBlockMetadata(final @Nullable Player player, final @NotNull ItemStack stack, final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side, final double xHit, final double yHit) {
         return this.getPlacedData(player, stack, world, new TilePos(x, y, z), side, xHit, yHit);
     }
 
-    boolean isClimbable(final @NotNull World world, final @NotNull TilePos tilePos);
+    boolean isClimbable(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean isClimbable(final @NotNull World world, final int x, final int y, final int z) {
         return this.isClimbable(world, new TilePos(x, y, z));
     }
 
-    boolean isEquivalent(final @NotNull World world, final @NotNull TilePos thisPos, final @NotNull TilePos thatPos);
+    boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos);
 
     @Deprecated
     default boolean isEquivalent(final @NotNull World world, final int thisX, final int thisY, final int thisZ, final int thatX, final int thatY, final int thatZ) {
         return this.isEquivalent(world, new TilePos(thisX, thisY, thisZ), new TilePos(thatX, thatY, thatZ));
     }
 
-    @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePos tilePos);
+    @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @NotNull Side getAttachedSide(final @NotNull WorldSource source, final int x, final int y, final int z) {
